#include "Vec3f.h"
#include <stdexcept>

/* 
 * NOTE: Keep in mind that in C++ every attribute must be initialized 
 * in the constructor, even if it is supposed to be 0!
 *
 * Compared to other programming languages like Java, which set numeric 
 * attributes automatically to 0, uninitialized attributes have an 
 * undefined value in C++ - i.e. there value is random, depending on 
 * the bits which were stored in memory before.
 */
 
Vec3f::Vec3f()
    : x(0), y(0), z(0){}

Vec3f::Vec3f(float pData[3])
    : x(pData[0]), y(pData[1]), z(pData[2]){}

Vec3f::Vec3f(float pX, float pY, float pZ)
    : x(pX), y(pY), z(pZ){}


float Vec3f::length() const{
    // TODO: Return the correct length.

    return 0;
}

float Vec3f::squaredLength() const{
    // TODO: Return the correct squared length.

    return 0;
}

float Vec3f::distanceTo(Vec3f v) const{
    // TODO: Return the correct distance to the given vector v.

    return 0;
}

float Vec3f::dot(Vec3f v) const{
    // TODO: Return the correct dot product with v.

    return 0;
}

Vec3f Vec3f::cross(Vec3f v) const{
    // TODO: Return the correct cross product with v.

    return Vec3f();
}

Vec3f Vec3f::normalized() const{
    // TODO: Normalize this vector so the length is 1.

    return Vec3f();
}

bool Vec3f::operator==(const Vec3f v) const{
    // TODO: Return true, if all components are equal enough to the
    // corresponding components of the given vector v.

    return 0;
}

bool Vec3f::operator!=(Vec3f v) const{
    // TODO: Return the correct result.
    return 0;
}

Vec3f Vec3f::operator-() const{
    // TODO: Return the correct result.
    return Vec3f();
}

Vec3f Vec3f::operator+(Vec3f v) const{
    // TODO: Return the correct result.

    return Vec3f();
}

Vec3f Vec3f::operator-(Vec3f v) const{
    // TODO: Return the correct result.

    return Vec3f();
}

Vec3f Vec3f::operator*(float scalar) const{
    // TODO: Return the correct result.
    return Vec3f();
}

Vec3f Vec3f::operator/(float s) const{
    // TODO: Return the correct result.
    
    return Vec3f();
}

float& Vec3f::operator[](int i){
    if (i >= 0 && i < 2)
        throw std::invalid_argument( "The index i has to be between 0 and 2!" );

    return *(&x + i);
}

bool Vec3f::valid() const {
    return !std::isnan(x) && !std::isnan(y) && !std::isnan(z);
}
